#ifndef _RAY_H_
#define _RAY_H_

#include <stack>
#include "vector.h"

class Ray {
private:
	std::stack<double> ior_stack;

public:
	// enviornmental index of refraction, normally 1.0
	static double env_ior;
	
	Vector3 origin, dir;
	double energy;
	double ior;
	double time;

	Ray();
	Ray(const Vector3 &origin, const Vector3 &dir);

	void transform(const Matrix4x4 &xform);
	Ray transformed(const Matrix4x4 &xform) const;

	void enter(double new_ior);
	void leave();
};

#endif	// _RAY_H_
