/** 
 * @file vmath.inl
 * @author John Tsiombikas
 * @date 28 June 2005
 *
 * vmath inline functions.
 */

#include "quaternion.h"

/** linear interpolation */
inline scalar_t lerp(scalar_t a, scalar_t b, scalar_t t) {
	return a + (b - a) * t;
}

/*
inline Vector3 lerp(const Vector3 &a, const Vector3 &b, scalar_t t) {
	return a + (b - a) * t;
}

inline Quaternion lerp(const Quaternion &a, const Quaternion &b, scalar_t t) {
	return slerp(a, b, t);
}
*/

/** b-spline approximation */
inline scalar_t bspline(scalar_t a, scalar_t b, scalar_t c, scalar_t d, scalar_t t) {
	return bspline(Vector4(a, b, c, d), t);
}

/** catmull-rom spline interpolation */
inline scalar_t catmull_rom_spline(scalar_t a, scalar_t b, scalar_t c, scalar_t d, scalar_t t) {
	return catmull_rom_spline(Vector4(a, b, c, d), t);
}
